<?php
///////////////////////////////////////////////////////////////////////////
require_once 'skins/skins.php';

class legichSkin extends ExUaSkin
{
    public function __construct()
    {
        parent::__construct();
    }
    
    public function get_short_name()
    {
        return 'legich';
    }

    public function get_long_name()
    {
        return 'Minimal Bokeh';
    }

    public function get_main_icon_path()
    {
        return '/skins/legich/icons/exua.png';
    }

    public function get_settings_icon_path()
    {
        return '/skins/legich/icons/exua_setting.png';
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          MAIN SCREEN
//
    public function GET_MAIN_MENU_FOLDER_VIEWS($plugin_cookies)
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => false,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 4,                                //edit
                            ViewParams::num_rows => 2,

                            ViewParams::icon_selection_box_dx => -118,                //edit
                            ViewParams::icon_selection_box_dy => -154,                //edit
                            ViewParams::icon_selection_box_width => 240,              //edit
                            ViewParams::icon_selection_box_height => 240,             //edit

                            ViewParams::paint_sandwich => true,                       //edit
                            ViewParams::sandwich_base => 'plugin_file://skins/legich/icons/sandwich_base.png',
                            ViewParams::sandwich_width => 200,                        //edit
                            ViewParams::sandwich_height => 200,                       //edit
                            ViewParams::sandwich_icon_upscale_enabled => false,        

                            ViewParams::paint_details => false                        //edit
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::icon_scale_factor =>1.0,                  //edit
                            ViewItemParams::icon_sel_scale_factor =>1.2,              //edit
                            ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                            ViewItemParams::item_layout => VALIGN_CENTER,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::item_caption_dy => -50,                   //edit
                            ViewItemParams::item_caption_sel_dy => -15,               //edit
                            ViewItemParams::icon_dy => -14,                           //edit
                            ViewItemParams::icon_sel_dy => -14,                       //edit

                            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL//,
                        ),
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    )
                );
    }

    public function get_main_items_view_params_video($plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_path => 'plugin_file://skins/legich/icons/exua_video.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }

    public function get_main_items_view_params_audio($plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_path => 'plugin_file://skins/legich/icons/exua_audio.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }
    
    public function get_main_items_view_params_search($plugin_cookies)
    {
        return array
                (
                    ViewItemParams::icon_path => 'plugin_file://skins/legich/icons/exua_search.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }

    public function get_main_items_view_params_favorites($plugin_cookies)
    {
        return array
        (
            ViewItemParams::icon_path => 'plugin_file://skins/legich/icons/exua_favorites.png',
            ViewItemParams::item_layout => HALIGN_CENTER,
            ViewItemParams::icon_valign => VALIGN_CENTER,
            ViewItemParams::item_paint_caption_within_icon => false,
            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        );
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          CATEGORY LIST SCREEN
//

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          VOD LIST SCREEN
//

}
///////////////////////////////////////////////////////////////////////////
?>
