<?php
///////////////////////////////////////////////////////////////////////////
class ExUaSkin
{
    public function __construct()
    {
    }

    public function get_short_name()
    {
        return 'build_in';
    }

    public function get_long_name()
    {
        return 'Встроеный';
    }
    
    public function get_main_icon_path()
    {
        return '/icons/exua.png';
    }

    public function get_settings_icon_path()
    {
        return '/icons/exua_settings.png';
    }
//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          MAIN SCREEN
//
    public function GET_MAIN_MENU_FOLDER_VIEWS($plugin_cookies)
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => false,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 3,
                            ViewParams::num_rows => 2,

                            ViewParams::icon_selection_box_dx => -130,
                            ViewParams::icon_selection_box_dy => -130,
                            ViewParams::icon_selection_box_width => 275,
                            ViewParams::icon_selection_box_height => 255,

                            ViewParams::paint_sandwich => true,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 270,
                            ViewParams::sandwich_height => 250,
                            ViewParams::sandwich_icon_upscale_enabled => true,

                            ViewParams::paint_details => true
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::icon_scale_factor =>0.75,
                            ViewItemParams::icon_sel_scale_factor =>1,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                            ViewItemParams::item_layout => VALIGN_CENTER,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ),
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    )
               );
    }
    
    public function get_main_items_view_params_video($plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_path => 'plugin_file://icons/exua.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }

    public function get_main_items_view_params_audio($plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_path => 'plugin_file://icons/exua.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }
    
    public function get_main_items_view_params_search($plugin_cookies)
    {
        return array
        (
            ViewItemParams::icon_path => 'plugin_file://icons/exua_search.png',
            ViewItemParams::item_layout => HALIGN_CENTER,
            ViewItemParams::icon_valign => VALIGN_CENTER,
            ViewItemParams::item_paint_caption_within_icon => false,
            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        );
    }

    public function get_main_items_view_params_favorites($plugin_cookies)
    {
        return array
        (
            ViewItemParams::icon_path => 'plugin_file://icons/exua_favorites.png',
            ViewItemParams::item_layout => HALIGN_CENTER,
            ViewItemParams::icon_valign => VALIGN_CENTER,
            ViewItemParams::item_paint_caption_within_icon => false,
            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        );
    }
//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          CATEGORY LIST SCREEN
//
    public static $catalog_vip = array
    (
        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
        ViewItemParams::item_layout => HALIGN_LEFT,
        ViewItemParams::icon_valign => VALIGN_CENTER,
        ViewItemParams::icon_dx => 20,
        ViewItemParams::icon_dy => -5,
        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        ViewItemParams::item_caption_width => 1550
    );
    
    public function GET_VOD_CATEGORY_LIST_FOLDER_VIEWS($plugin_cookies)
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => false,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 12
                        ),

                        PluginRegularFolderView::base_view_item_params => self::$catalog_vip,
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    )
                );
    }

    public function get_category_items_view_params($plugin_cookies)
    {
        return self::$catalog_vip;
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          VOD LIST SCREEN
//
    private static function get_loading_items($view_type)
    {
        $items =    array
                    (
                        array
                        (
                            PluginRegularFolderItem::caption =>
                                'Загрузка...',
                                PluginRegularFolderItem::view_item_params => array
                                (
                                    ViewItemParams::item_paint_icon => true,
                                    ViewItemParams::item_layout => HALIGN_LEFT,
                                    ViewItemParams::icon_valign => VALIGN_CENTER,
                                    ViewItemParams::icon_dx => 10,
                                    ViewItemParams::icon_width => ($view_type == 1 ? 190 : ($view_type == 2 ? 150 : 50)),
                                    ViewItemParams::icon_height => ($view_type == 1 ? 290 : ($view_type == 2 ? 150 : 50)),
                                    ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai'),
                                    ViewItemParams::item_caption_width => 950,
                                    ViewItemParams::item_detailed_icon_path => 'missing://'
                                ),
                            PluginRegularFolderItem::media_url => 'dummy'
                        )
                    );

        return  array
                (
                    PluginRegularFolderRange::total => count($items),
                    PluginRegularFolderRange::count => count($items),
                    PluginRegularFolderRange::more_items_available => 1,
                    PluginRegularFolderRange::from_ndx => 0,
                    PluginRegularFolderRange::items => $items
                );
    }
    public function GET_VOD_MOVIE_LIST_FOLDER_VIEWS(&$plugin_cookies)
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => true,
                        PluginRegularFolderView::initial_range => self::get_loading_items(1),

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 5,
                            ViewParams::num_rows => 2,
                            ViewParams::paint_details => true,
//                            ViewParams::zoom_detailed_icon => true,
                            ViewParams::detailed_icon_scale_factor => 0,
                            ViewParams::paint_item_info_in_details => true,
                            ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,

                            ViewParams::paint_sandwich => true,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 190,
                            ViewParams::sandwich_height => 290,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),
                        
                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 190,
                            ViewItemParams::icon_height => 290,
                            ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 190,
                            ViewItemParams::icon_height => 290,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => false,
                            ViewItemParams::item_caption_width => 1100
                        ),
                    ),
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => true,
                        PluginRegularFolderView::initial_range => self::get_loading_items(2),

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 3,
                            ViewParams::paint_details => true,
                            ViewParams::zoom_detailed_icon => true,
                            ViewParams::paint_item_info_in_details => true,
                            ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,

                            ViewParams::paint_sandwich => false,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 190,
                            ViewParams::sandwich_height => 290,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),

                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 150,
                            ViewItemParams::icon_height => 200,
                            ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 150,
                            ViewItemParams::icon_height => 200,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => true,
                            ViewItemParams::item_caption_width => 950
                        ),
                    ),
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => true,
                        PluginRegularFolderView::initial_range => self::get_loading_items(3),

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,               
                            ViewParams::num_rows => 10,
                            ViewParams::paint_details => true,
                            ViewParams::zoom_detailed_icon => true,
                            ViewParams::paint_item_info_in_details => true,
                            ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,

                            ViewParams::paint_sandwich => false,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 190,
                            ViewParams::sandwich_height => 290,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),

                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 50,
                            ViewItemParams::icon_height => 50,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 50,
                            ViewItemParams::icon_height => 50,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => true,
                            ViewItemParams::item_caption_width => 1100
                        ),
                    )
                 );
    }

    public function get_vod_movie_items_view_params($info, $poster_url, $view_type, &$plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_width => ($view_type == 0 ? 190 : ($view_type == 1 ? 150 : 50)),
                    ViewItemParams::icon_height => ($view_type == 0 ? 290 : ($view_type == 1 ? 150 : 50)),
                    ViewItemParams::item_detailed_info => $info ? $info : '',
                    ViewItemParams::item_detailed_icon_path => $poster_url ? $poster_url : 'missing://',
                    ViewItemParams::icon_path => $view_type == 2 ? 'gui_skin://small_icons/movie.aai' : ($poster_url ? $poster_url : 'gui_skin://large_icons/movie.aai'),
                );
    }
//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          TEXT ONE LIST SCREEN
//
    public function GET_TEXT_ONE_COL_VIEWS()
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => false,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 12
                        ),

                        PluginRegularFolderView::base_view_item_params => self::$catalog_vip,
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    )
                );
    }

    public function get_text_one_items_view_params($plugin_cookies)
    {
        return self::$catalog_vip;
    }
}

class ExUaSkins
{
    const BUILDIN_SKIN_NAME = 'build_in';

    private $skins_path     = '';
    private $plugun_path    = '';
    private $skin_list      = array();
    private $current_skin   = null;

    public function __construct($plugin_path, $skins_path)
    {
        $this->skins_path = $skins_path;
        $this->plugin_path = $plugin_path;
        
        $this->skin_list[self::BUILDIN_SKIN_NAME] = new ExUaSkin();
//        $current_skin = $skin_list['build_in'];
        
        $this->init_skins();
    }
    
    private function is_valid_skin_dir($name)
    {
        $php_file_name = $this->get_skin_path($name);
        $php_file_name .= '/skin.php';
        
        return is_file($php_file_name);
    }
    
    private function get_skin_path($name)
    {
        return $this->skins_path . '/' . $name;
    }
    
    private function create_skin($name)
    {
        $req_path = 'skins/' . $name . '/' . 'skin.php';
        
        require_once $req_path;
        
        $class_name = $name . 'Skin';
        return new $class_name;
    }
    
    private function init_skins()
    {
        $ls = shell_exec("ls " . $this->skins_path);

        hd_print("--->>> ls: $ls");
        
        if (strlen($ls) == 0)
            return;
        
        $dirs = explode(chr(10), $ls);
        
        foreach ($dirs as $d)
        {
            if (strlen($d) == 0)
                continue;
            
            $skin_dir = $this->get_skin_path($d);
            if (!is_dir($skin_dir))
                continue;
            
            if (!$this->is_valid_skin_dir($d))
                continue;
                
            $skin = $this->create_skin($d);
            $this->skin_list[$skin->get_short_name()] = $skin;
        }
        
        return;
    }
    
    public function get_skin_names()
    {
        $names = array();
        foreach ($this->skin_list as $skin)
        {
            $names[] =  array
                        (
                            'name_idx' => $skin->get_short_name(),
                            'name' => $skin->get_long_name()
                        );
        }
        
        return $names;
    }
    
    public function get_current_skin(&$plugin_cookies)
    {
	$skin = isset($plugin_cookies->skin) ? $plugin_cookies->skin : self::BUILDIN_SKIN_NAME;

        if (isset($this->skin_list[$skin]))
            return $this->skin_list[$skin];
        
        return $this->skin_list[self::BUILDIN_SKIN_NAME];
    }
    
    public function update_main_icons(&$plugin_cookies)
    {
        $main_icon = $this->get_current_skin($plugin_cookies)->get_main_icon_path();
        shell_exec('cp -f ' . $this->plugin_path . $main_icon . ' ' . $this->plugin_path . '/main_icons/exua.png');

        $settings_icon = $this->get_current_skin($plugin_cookies)->get_settings_icon_path();
        shell_exec('cp -f ' . $this->plugin_path . $settings_icon . ' ' . $this->plugin_path . '/main_icons/exua_settings.png');
    }
}
///////////////////////////////////////////////////////////////////////////
?>
