<?php
///////////////////////////////////////////////////////////////////////////
require_once 'skins/skins.php';

class urdosSkin extends ExUaSkin
{
    public function __construct()
    {
        parent::__construct();
    }
    
    public function get_short_name()
    {
        return 'urdos';
    }

    public function get_long_name()
    {
        return 'От Urdos';
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          MAIN SCREEN
//
    public function GET_MAIN_MENU_FOLDER_VIEWS($plugin_cookies)
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => false,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 4,
                            ViewParams::num_rows => 1,

                            ViewParams::paint_path_box => false,
                            ViewParams::background_path=> 'plugin_file://skins/urdos/icons/background.png',
                            ViewParams::background_order => 0,
                            ViewParams::background_height=> 1080,
                            ViewParams::background_width=> 1920,
                            ViewParams::optimize_full_screen_background => true,
                            ViewParams::paint_content_box_background => false,
                            ViewParams::paint_icon_selection_box=> false , 
                            ViewParams::paint_icon_badge_box => false,
                            ViewParams::paint_icon_selection_box => false,
                            ViewParams::icon_selection_box_dx => -130,
                            ViewParams::icon_selection_box_dy => -130,
                            ViewParams::icon_selection_box_width => 275,
                            ViewParams::icon_selection_box_height => 255,
                            ViewParams::paint_sandwich => true,
                            ViewParams::sandwich_base => 'plugin_file://skins/urdos/icons/sandwich_.png',
                            ViewParams::sandwich_mask => 'plugin_file://skins/urdos/icons/sandwich_mask.png',
                            ViewParams::sandwich_cover => 'plugin_file://skins/urdos/icons/sandwich_cover.png',
                            ViewParams::sandwich_width => 270,
                            ViewParams::sandwich_height => 154,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::paint_details => false,
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::item_layout => HALIGN_CENTER,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::item_paint_caption => false,
                            ViewItemParams::icon_scale_factor => 1.25,
                            ViewItemParams::icon_sel_scale_factor => 1.5,
                        ),
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    )
                );
    }

    public function get_main_items_view_params_video($plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_path => 'plugin_file://skins/urdos/icons/exua_video.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }

    public function get_main_items_view_params_audio($plugin_cookies)
    {
        return  array
                (
                    ViewItemParams::icon_path => 'plugin_file://skins/urdos/icons/exua_audio.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                );
    }
    
    public function get_main_items_view_params_search($plugin_cookies)
    {
        return array
        (
            ViewItemParams::icon_path => 'plugin_file://skins/urdos/icons/exua_search.png',
            ViewItemParams::item_layout => HALIGN_CENTER,
            ViewItemParams::icon_valign => VALIGN_CENTER,
            ViewItemParams::item_paint_caption_within_icon => false,
            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        );
    }

    public function get_main_items_view_params_favorites($plugin_cookies)
    {
        return array
        (
            ViewItemParams::icon_path => 'plugin_file://skins/urdos/icons/exua_favorites.png',
            ViewItemParams::item_layout => HALIGN_CENTER,
            ViewItemParams::icon_valign => VALIGN_CENTER,
            ViewItemParams::item_paint_caption_within_icon => false,
            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        );
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          CATEGORY LIST SCREEN
//
    public static $catalog_vip = array
    (
        ViewItemParams::icon_path => 'plugin_file://skins/urdos/icons/pop.aai',
        ViewItemParams::item_layout => HALIGN_LEFT,
        ViewItemParams::icon_valign => VALIGN_CENTER,
        ViewItemParams::icon_dx => 20,
        ViewItemParams::icon_dy => -5,
        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        ViewItemParams::item_caption_width => 1550
    );
    public function GET_VOD_CATEGORY_LIST_FOLDER_VIEWS($plugin_cookies)
    {
        return  array
                (
                    array
                    (
                        PluginRegularFolderView::async_icon_loading => false,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 12
                        ),

                        PluginRegularFolderView::base_view_item_params => self::$catalog_vip,
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    )    
                 );
    }
    public function get_category_items_view_params($plugin_cookies)
    {
        return self::$catalog_vip;
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//          VOD LIST SCREEN
//

}
///////////////////////////////////////////////////////////////////////////
?>
