<?php

class ExUaConfig
{
    const VERSION_MAJOR                     = '8';
    const VERSION_MINOR                     = '1';
    const VERSION_SUBMINOR                  = '0';
    const VERSION_DATE                      = '15.12.12';
    const VERSION_TIME                      = '00:50';
    
    const PLUGIN_PATH                       = '/persistfs/plugins/Ex.ua';
    const PLUGIN_PATH_FLASH                 = '/flashdata/plugins/Ex.ua';
    const SKINS_PATH                        = '/persistfs/plugins/Ex.ua/skins';
    const SKINS_PATH_FLASH                  = '/flashdata/plugins/Ex.ua/skins';
    
    const VOD_MOVIE_PAGE_SUPPORTED          = true;
    const VOD_FAVORITES_SUPPORTED           = true;
    const VOD_SECTION_SEARCH_SUPPORTED      = true;

    const VOD_CATEGORIES_URL                = 'http://www.ex.ua/ru/video';
    const VOD_CATEGORIES_DELIMITER          = "<td align=center valign=center><a href='/ru/video/";
    
    const AUDIO_CATEGORIES_URL              = 'http://www.ex.ua/ru/audio'; 
    const AUDIO_CATEGORIES_DELIMITER        = "<td align=center valign=center><a href='/view/";
    
    const VOD_LANGUAGES_URL                 = 'http://www.ex.ua/view/81708'; 
    const VOD_LANGUAGES_DELIMITER           = "<td align=center valign=center><a href='";
    const VOD_LANGUAGES_CATEGORY_DELIMITER  = "<td align=center valign=center><a href='/view/";
    
    const AUDIO_LANGUAGES_URL                 = 'http://www.ex.ua/view/81709'; 
    const AUDIO_LANGUAGES_DELIMITER           = "<td align=center valign=center><a href='";
    const AUDIO_LANGUAGES_CATEGORY_DELIMITER  = "<td align=center valign=center><a href='/view/";

    const MOVIE_LIST_URL_FORMAT             = 'http://www.ex.ua%s&v=1,0&per=20';
    const MOVIE_PAGE_URL_FORMAT             = 'http://www.ex.ua/view/%s';

    const SEARCH_MOVIE_LIST_URL_FORMAT              = 'http://www.ex.ua/search?s=%s';
    const SEARCH_MOVIE_LIST_PAGE_URL_FORMAT         = 'http://www.ex.ua/search?s=%s&p=%s';

    const SEARCH_CATEGORY_MOVIE_LIST_URL_FORMAT         = 'http://www.ex.ua/search?%s&s=%s';
    const SEARCH_CATEGORY_MOVIE_LIST_PAGE_URL_FORMAT    = 'http://www.ex.ua/search?%s&s=%s&p=%s';

    const FAV_MOVIES_CATEGORY_CAPTION       = 'Избранное';
    const FAV_MOVIES_CATEGORY_ICON_PATH     = 'plugin_file://icons/exua_favorites.png';

}

?>
